#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.add = void 0;
const inquirer_1 = __importDefault(require("inquirer"));
const chalk_1 = __importDefault(require("chalk"));
const fs_1 = __importDefault(require("fs"));
const log_symbols_1 = __importDefault(require("log-symbols"));
const utils_1 = require("./utils");
const add = () => __awaiter(void 0, void 0, void 0, function* () {
    const template = Promise.resolve().then(() => __importStar(require((0, utils_1.resolve)('../template'))));
    let templateObj = yield template;
    templateObj = templateObj.default;
    const question = [
        {
            name: "name",
            type: 'input',
            message: "请输入模板名称",
            validate: (val) => {
                if (val === '') {
                    return 'Name is required!';
                }
                else if (templateObj[val]) {
                    return 'Template has already existed!';
                }
                else {
                    return true;
                }
            }
        },
        {
            name: "url",
            type: 'input',
            message: "请输入模板地址",
            validate: (val) => {
                if (val === '')
                    return 'The url is required!';
                return true;
            }
        },
        {
            name: "description",
            type: 'input',
            message: "请输入模板描述",
            validate: (val) => {
                if (val.length >= '70')
                    return 'The description is more than 70 characters!';
                return true;
            }
        }
    ];
    const answers = yield inquirer_1.default.prompt(question);
    const { name, url, description } = answers || {};
    templateObj[name] = {
        url,
        description
    };
    fs_1.default.writeFile((0, utils_1.resolve)('../template.json'), JSON.stringify(templateObj, null, 2), 'utf-8', err => {
        if (err)
            console.log(err);
        console.log('\n');
        console.log(log_symbols_1.default.success, chalk_1.default.green('Added successfully!\n'));
        console.log(chalk_1.default.grey('The latest template list is: \n'));
        console.log(templateObj);
        console.log('\n');
    });
});
exports.add = add;
