#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const commander_1 = require("commander");
const chalk_1 = __importDefault(require("chalk"));
const create_1 = require("./create");
const add_1 = require("./add");
const list_1 = require("./list");
const delete_1 = require("./delete");
const program = new commander_1.Command();
program
    .version(require('../version').version)
    .name('yx-cli');
program
    .command('create <project-name>')
    .description('Create a new project')
    .option('-f --force', 'If it exist, overwrite directory')
    .action((projectName, options) => {
    (0, create_1.create)(projectName, options);
});
program
    .command('add')
    .description('Add a new template')
    .action(() => {
    (0, add_1.add)();
});
program
    .command('list')
    .description('List all the template')
    .action(() => {
    (0, list_1.list)();
});
program
    .command('delete')
    .description('Delete a template')
    .action(() => {
    (0, delete_1.del)();
});
program.on('--help', () => {
    console.log(`\r\n Run ${chalk_1.default.green(`yx-cli <command> --help`)} to understand the details\r\n `);
});
program.parse(process.argv);
