"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.hasPackage = exports.resolve = exports.shellExec = exports.readFile = void 0;
const fs_1 = require("fs");
const ora_1 = __importDefault(require("ora"));
const child_process_1 = require("child_process");
const path_1 = __importDefault(require("path"));
const readFile = (filePath) => {
    let file = null;
    try {
        file = (0, fs_1.readFileSync)(filePath);
        file = JSON.parse(file.toString());
    }
    catch (error) {
        file = (0, fs_1.readFileSync)(filePath);
        file = file.toString('utf-8');
    }
    return file;
};
exports.readFile = readFile;
const shellExec = (config) => {
    const { directive, cwd, loading, log } = config || {};
    return new Promise((resolve, reject) => {
        log && console.log(`\n ${log} \n`);
        const spinner = (0, ora_1.default)(loading);
        loading && spinner.start();
        (0, child_process_1.exec)(directive, { cwd }, (error, stdout) => {
            if (error) {
                loading && spinner.fail();
                console.log(stdout);
                reject(error);
                return;
            }
            resolve(stdout);
            loading && spinner.succeed();
        });
    });
};
exports.shellExec = shellExec;
const resolve = (...file) => path_1.default.resolve(__dirname, ...file);
exports.resolve = resolve;
const hasPackage = () => {
    const fn = (tool) => {
        try {
            (0, child_process_1.execSync)(`${tool} --version`, { stdio: 'ignore' });
            return true;
        }
        catch (e) {
            return false;
        }
    };
    return fn;
};
exports.hasPackage = hasPackage;
